#if !defined(AFX_ARRAYVIEW_H__2EEC4942_51EA_11D2_8CB3_FB5BEE035FF0__INCLUDED_)
#define AFX_ARRAYVIEW_H__2EEC4942_51EA_11D2_8CB3_FB5BEE035FF0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

enum TAttr { WIDTH, COLOR, LENGTH };
enum TFind { Known, Find };

class CArrayView : public CView {
	friend class CAttrDlg;
protected:
	CArrayView();
	DECLARE_DYNCREATE(CArrayView)
public:
	CDrawingDoc* GetDocument();
	POSITION SelectItem(TFind);
	void GetLine();
	void SetLine (int);
	void InsertNew();
	void InsertLine (int);
	void ChangeLine(TAttr);
	void Refresh();
	void Fill();
	//{{AFX_VIRTUAL(CArrayView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL
protected:
	virtual ~CArrayView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//{{AFX_MSG(CArrayView)
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLineSize();
	afx_msg void OnLinePoints();
	afx_msg void OnLineDel();
	afx_msg void OnLineColor();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CDrawingDoc *pDoc;
	CLine* pLine;
	CListCtrl * pList;
	int CurSel, nItems;
	UINT PenSize, Red, Green, Blue, nPoints;
	COLORREF Color;
};

#ifndef _DEBUG
inline CDrawingDoc* CDrawingView::GetDocument()
   { return (CDrawingDoc*)m_pDocument; }
#endif

// CAttrDlg dialog

class CAttrDlg : public CDialog {
public:
	CArrayView *pView;
	TAttr Attr;
	CAttrDlg(CWnd*, TAttr);
	//{{AFX_DATA(CAttrDlg)
	enum { IDD = IDD_ATTRIB };
	//}}AFX_DATA
	//{{AFX_VIRTUAL(CAttrDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL
protected:
	//{{AFX_MSG(CAttrDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}
#endif
