#include "stdafx.h"
#include "Drawing.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "IpFrame.h"
#include "DrawingDoc.h"
#include "DrawingView.h"
#include "ArrayView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CDrawingApp, CWinApp)
	//{{AFX_MSG_MAP(CDrawingApp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

CDrawingApp::CDrawingApp(){}

CDrawingApp theApp;

static const CLSID clsid =
{ 0xf406bf44, 0x5a1d, 0x11d2, { 0x8c, 0xb3, 0xfb, 0x5b, 0xee, 0x3, 0x5f, 0xf0 } };

BOOL CDrawingApp::InitInstance() {
	if (!AfxOleInit())	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	Enable3dControls();
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings();
	pTemplDraw = new CMultiDocTemplate(
		IDR_DRAWINGTYPE,
		RUNTIME_CLASS(CDrawingDoc),
		RUNTIME_CLASS(CChildFrame),
		RUNTIME_CLASS(CDrawingView));

	pTemplDraw->SetServerInfo(IDR_DRAWINTYPE_SRVR_EMB, IDR_DRAWINTYPE_SRVR_IP,
								RUNTIME_CLASS(CInPlaceFrame));
	
	pTemplDraw->SetContainerInfo(IDR_DRAWINTYPE_CNTR_IP);	
		
	AddDocTemplate(pTemplDraw);
	pTemplArray = new CMultiDocTemplate(
		IDR_ARRAYTYPE,
		RUNTIME_CLASS(CDrawingDoc),
		RUNTIME_CLASS(CChildFrame),
		RUNTIME_CLASS(CArrayView));
		
	m_server.ConnectTemplate(clsid, pTemplDraw, FALSE);
	COleTemplateServer::RegisterAll();
	
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)	{
		return TRUE;
	}
	m_server.UpdateRegistry(OAT_INPLACE_SERVER);

	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	pMainFrame->ShowWindow(SW_SHOWMAXIMIZED);
	pMainFrame->UpdateWindow();
	return TRUE;
}

// CLine Class
IMPLEMENT_SERIAL(CLine, CObject, 2)

CLine::CLine() {}

CLine::CLine(UINT size, COLORREF color) {
	PenSize = size;
	Color = color;
	rect.SetRectEmpty();
}

CLine::~CLine() { Points.RemoveAll(); }

void const CLine::Draw(CDC* pDC)
{							//   
	CPen pen;
							//     
	if (!pen.CreatePen(PS_SOLID, PenSize, Color))
		return;
							//    ,  
	CPen* pOld = pDC->SelectObject(&pen);
							//     
	CPoint ptFirst = Points[0];
	pDC->MoveTo (ptFirst);
							//    
	for (int i=1;  i<Points.GetSize();  i++)
		pDC->LineTo (Points[i]+ptFirst);		//  
	pDC->SelectObject(pOld);						//  
}

void CLine::Serialize (CArchive& ar) {
	if (ar.IsStoring())	{
		ar<<PenSize<<Color<<rect;
	}
	else {
		ar>>PenSize>>Color>>rect;
	}
	Points.Serialize(ar);
}

void CLine::CalcRect(CRect& r)
{				//    
	CPoint ptFirst = Points[0];			//   
	CPoint p = ptFirst;	
				//    
	r = CRect (p.x, p.y, p.x, p.y);
	for (int i=1;  i<Points.GetSize();  i++)
	{										//     
		p = ptFirst + Points[i];				
											//  
		r.left		= min(r.left, p.x);
		r.right		= max(r.right, p.x);
		r.top		= min(r.top, p.y);
		r.bottom	= max(r.bottom, p.y);
	}
									//   
	r.InflateRect(CSize(PenSize, PenSize));
}

void CLine::SetRect(CRect& rMax)
{		//    
	CalcRect(rect);
	rMax.left		= min(rMax.left, rect.left);
	rMax.right	= max(rMax.right, rect.right);
	rMax.top		= min(rMax.top, rect.top);
	rMax.bottom	= max(rMax.bottom, rect.bottom);
}


CRect& CLine::GetRect() { return rect; }

