#if !defined(AFX_DRAWINGDOC_H__DD4462E3_4119_11D2_8CB3_FB5BEE035FF0__INCLUDED_)
#define AFX_DRAWINGDOC_H__DD4462E3_4119_11D2_8CB3_FB5BEE035FF0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

class CPenDlg;
class CDrawingSrvrItem;
class CDrawingCntrItem;

class CDrawingDoc : public COleServerDoc {
	friend class CDrawingView;
	friend class CArrayView;
	friend class CPenDlg;
	friend class CDrawingSrvrItem;
	friend class CMainFrame;
protected:
	CDrawingDoc();
	DECLARE_DYNCREATE(CDrawingDoc)

	//{{AFX_VIRTUAL(CDrawingDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnNewDocument();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnShowViews(BOOL bVisible);
	protected:
	virtual COleServerItem* OnGetEmbeddedItem();	
	//}}AFX_VIRTUAL

public:
	static CLIPFORMAT cfClipb;

	void Recalc(CPoint&);
	void DeleteSketch();
	void DoPaste(CDocument*);
	CDrawingCntrItem* CreateItem();
	void ShiftItem(CDrawingCntrItem*);

	virtual ~CDrawingDoc();
	CDrawingSrvrItem* GetEmbeddedItem()
		{ return (CDrawingSrvrItem*)COleServerDoc::GetEmbeddedItem(); }
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//{{AFX_MSG(CDrawingDoc)
	afx_msg void OnEditClearAll();
	afx_msg void OnUpdateEditClearAll(CCmdUI* pCmdUI);
	afx_msg void OnEditColor();
	afx_msg void OnEditPen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	UINT PenSize;
	COLORREF Color;
	CSketch Sketch;
	CSize szDoc, szSrvr;
	CRect rMax;			// ,   
	bool bFirst;		//  :   
	bool bNeedUpdate;
};

//{{AFX_INSERT_LOCATION}}

#endif
