#include "stdafx.h"
#include "Drawing.h"

#include "DrawingDoc.h"
#include "CntrItem.h"
#include "SrvrItem.h"
#include "DrawingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CLIPFORMAT CDrawingView::cfDraw = NULL;

IMPLEMENT_DYNCREATE(CDrawingView, CScrollView)

BEGIN_MESSAGE_MAP(CDrawingView, CScrollView)
	//{{AFX_MSG_MAP(CDrawingView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_SETCURSOR()
	ON_COMMAND(ID_CANCEL_EDIT_SRVR, OnCancelEditSrvr)
	ON_COMMAND(ID_CANCEL_EDIT_CNTR, OnCancelEditCntr)
	ON_COMMAND(ID_EDIT_DELOBJ, OnEditDelobj)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)	
	ON_COMMAND(ID_OLE_INSERT_NEW, OnOleInsertNew)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_OBJ_RESET, OnOleResetSize)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditMenu)
	ON_COMMAND(ID_OLE_EDIT_PROPERTIES, OnOleEditProperties)
	ON_COMMAND(ID_EDIT_PASTE_SPECIAL, OnEditPasteSpecial)
	ON_COMMAND(ID_OLE_CHANGE_SOURCE, OnOleChangeSource)
	ON_UPDATE_COMMAND_UI(ID_OLE_CHANGE_SOURCE, OnUpdateOleChangeSource)
	ON_COMMAND(ID_EDIT_CLONE, OnEditClone)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditMenu)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELOBJ, OnUpdateEditMenu)
	ON_UPDATE_COMMAND_UI(ID_OBJ_RESET, OnUpdateEditMenu)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_PROPERTIES, OnUpdateEditMenu)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

CDrawingView::CDrawingView() : ptFirst(0,0)
{
	pdc=0;							//    
	pLine=0;						//    
	pPen=0;							//   
	bDrag = false;					//    
	pTrack = 0;
	pHit = 0;
	trDraw.m_sizeMin.cx = 8;		//   
	trDraw.m_sizeMin.cy = 8;		//  
	trDraw.m_nStyle = 0;
	trDraw.m_nStyle |= CRectTracker::resizeInside | CRectTracker::solidLine;
	trObj.m_sizeMin.cy = 8;
	trObj.m_sizeMin.cy = 8;
	trObj.m_nStyle = 0;
	trObj.m_nStyle |= CRectTracker::resizeInside | CRectTracker::solidLine;
	if ( !cfDraw )		//     
		cfDraw = (CLIPFORMAT)::RegisterClipboardFormat (_T("Object Descriptor"));
	prevDrop = DROPEFFECT_NONE;
	bFromOutside = false;
}

CDrawingView::~CDrawingView() { }

void CDrawingView::OnDraw(CDC* pDC) {
	CDrawingDoc* pDoc = GetDocument();
	POSITION pos = pDoc->Sketch.GetHeadPosition();
	while (pos) {
		CLine *p = pDoc->Sketch.GetNext(pos);
		CRect rClip;  pDC->GetClipBox(&rClip);
		pDC->LPtoDP(&rClip);
		CRect rBound = p->GetRect();
		pDC->LPtoDP(&rBound);
		CRect r;  
		if (r.IntersectRect(&rClip,&rBound))
			p->Draw(pDC);
	}
										// Draw embedded items
	pos = pDoc->GetStartPosition();
	while (pos)	{
		CDrawingCntrItem* pItem = (CDrawingCntrItem*)pDoc->GetNextClientItem(pos);
		if (!pItem)	return;
		pItem->Draw(pDC, pItem->rObj);
		if (pDC->IsPrinting())	continue;
		CRect rTrue;
		SetupTracker(pItem, &rTrue);
		OnPrepareDC(pDC);
		pDC->DPtoLP(&rTrue);
		if (pDC->RectVisible(&rTrue))
			trObj.Draw(pDC);
	}
}

void CDrawingView::Drag(CPoint& point) { 
	pTrack->Track(this, point);
	CPoint pt = pTrack->m_rect.CenterPoint();
	CRect rCl; GetClientRect(rCl);
	if ( rCl.PtInRect(pt) ) {
		CClientDC dc(this);
		OnPrepareDC(&dc);
		if (pTrack == &trObj) {
			dc.DPtoLP(trObj.m_rect);
			pHit->ChangeSelection(trObj.m_rect);
		}
		else {
			dc.DPtoLP(&pt);
			GetDocument()->Recalc(pt);
		}
	}
	else 
		Invalidate();
	bDrag = false;
}

void CDrawingView::OnLButtonDown(UINT, CPoint point)
{							//   
	CDrawingDoc *pDoc = GetDocument();
	if (bDrag)				//    ,
		return;				//  

	HitTestItem(point); 	//    
	SetSelection(pHit);		//  ,   
							//    
	if ( !pHit )			//   ,  
	{						//    
		pLine = new CLine(pDoc->PenSize, pDoc->Color);
		pDoc->Sketch.AddTail (pLine);
		if ( pPen )
			pPen->DeleteObject();
		pPen = new CPen (PS_SOLID, pDoc->PenSize, pDoc->Color);
		pdc = new CClientDC(this);
		pdc->SelectObject(pPen);
		OnPrepareDC(pdc);
		pdc->DPtoLP(&point);
		pLine->Points.Add(point);
		pdc->MoveTo(ptFirst=point);
		SetCapture();
		return;				// ,   
	}
							//   
	CClientDC dc(this);		//   (   pdc)
	SetupTracker(pHit);		//    
	UpdateWindow();			//  

	if (trObj.HitTest(point) == CRectTracker::hitMiddle)
	{						//   drag
		CRect r = pHit->rObj;
		OnPrepareDC(&dc);
		dc.LPtoDP(&r);		//   Page space  Device space
							//   
		CPoint ptOff(point.x - r.left, point.y - r.top);
							//   1 
		CRect rDrag(r.left, r.top, r.left+1, r.top+1);
							// ,      
		bFromOutside = true;
							//    
		ClientToScreen(&r);
		ClientToScreen(&rDrag);
							//   (   )
		DROPEFFECT de = pHit->DoDragDrop(r, ptOff,
				TRUE,DROPEFFECT_COPY|DROPEFFECT_MOVE,&rDrag);
									//   
		if ( !bFromOutside )		//      ,
			return;					//  
		bFromOutside = false;		//  
									//   ,   
		if (de == DROPEFFECT_MOVE)
		{
			pDoc->UpdateAllViews(0,UPD_ITEM,pHit);
			DeleteItem(m_pSelection);
		}
	}								//  
	else if (trObj.Track(this, point))
	{								//     
		OnPrepareDC(&dc);
		dc.DPtoLP(trObj.m_rect);
		pHit->ChangeSelection(trObj.m_rect);
	}
}

void CDrawingView::OnLButtonUp(UINT, CPoint point)
{									//      , 
 	if (bDrag || !pdc)
 		return;	
 	CDrawingDoc * pDoc = GetDocument();
 	if ( !pDoc->bFirst )		
 	{								//     
 		pDoc->bFirst = true;
 		pDoc->rMax = CRect(point,point);
 	}
 									//   
 	pLine->SetRect(pDoc->rMax);
 	pDoc->SetModifiedFlag();
 									//     
 	pDoc->UpdateAllViews (this,UPD_NEWLINE,pLine);
 	delete pdc;
 	pdc = 0;						//   
	ReleaseCapture();				//  " "
	pDoc->NotifyChanged();
}

void CDrawingView::OnMouseMove(UINT, CPoint point)
{
	if ( bDrag )				//   , 
		Drag(point);			//    
	if ( !pdc )					//    ,  ,
		return;					//   
	pdc->DPtoLP(&point);
	pdc->LineTo (point);
	point -= ptFirst; 
	pLine->Points.Add(point);
}

void CDrawingView::OnRButtonDown(UINT nFlags, CPoint point)
{		//    ,    
	HitTestItem(point);
	SetSelection(pHit);
	if (pHit)						//      ,
	{								//   ,
		ClientToScreen(&point);
		CMenu menu;					//  ,
		if (menu.LoadMenu(ID_OBJ_POPUP))
		{							//     
			menu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTBUTTON,
					point.x, point.y,AfxGetMainWnd());
		}
	}			//      ,  
	else		//   ,     
	{			//     
		pTrack = &trDraw;
				//     
		trDraw.m_rect = GetDocument()->rMax;
		CClientDC dc(this);
		OnPrepareDC(&dc);
		dc.LPtoDP(&trDraw.m_rect);
				//       
		if (bDrag = trDraw.HitTest(point) >= 0)
				//        
			trDraw.Draw(&dc);
	}
}

void CDrawingView::OnUpdate(CView* pSender,LPARAM lHint, CObject* pHint)
{
 	CRect r;				//  
 	switch (lHint)
 	{						//    :
 	case UPD_WINDOW:		//    
		Invalidate();		//    
		m_pSelection = 0;
		break;
 	case UPD_LINE:			//   
 	case UPD_NEWLINE:		//   
 	{
 		CLine * p = (CLine*)pHint;		//   
 		r = p->GetRect();				//    
 
 							//   ,   
 		CClientDC dc(this);
 							//      
 		OnPrepareDC(&dc);
 							//       
 		dc.LPtoDP(&r);	
 
 		if (lHint==UPD_LINE)			//   ,
 		{
 			CRect rNew;					//  
 			p->CalcRect(rNew);			//  
 							//       
 			dc.LPtoDP(&rNew);
 			r.UnionRect(&r,&rNew);		//   
 		}
 							//   (  )
 		InvalidateRect(&r);
 	}
		m_pSelection = 0;
 		break;
	case UPD_ITEM:
	case UPD_DELITEM:
		if ( !pHint || !(pHint->IsKindOf(RUNTIME_CLASS(CDrawingCntrItem))))
			Invalidate();
		else {
			InvalidateItem((CDrawingCntrItem*)pHint);
			if (lHint == UPD_DELITEM && pHint == m_pSelection)
				m_pSelection = 0;// Specific case of pHint being deleted
		}
	}
}

void CDrawingView::InvalidateItem(CDrawingCntrItem* pItem) {
	if (m_nMapMode)	{
		CRect r;
		SetupTracker(pItem,&r);
		InvalidateRect(&r);
	}
}

void CDrawingView::OnInitialUpdate() {
 	CScrollView::OnInitialUpdate();
	CSize sz = GetDocument()->szDoc;
	CClientDC dc(this);
	sz.cx = MulDiv(sz.cx, dc.GetDeviceCaps(LOGPIXELSX), 100);
	sz.cy = MulDiv(sz.cy, dc.GetDeviceCaps(LOGPIXELSY), 100);
	SetScrollSizes(MM_TEXT, sz);
	m_pSelection = 0;
}

void CDrawingView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) {
    CScrollView::OnPrepareDC(pDC, pInfo);	//   
	pDC->SetMapMode(MM_ANISOTROPIC);		//    
    pDC->SetWindowExt(szLogScreen);			//  
    pDC->SetViewportExt(pDC->GetDeviceCaps(LOGPIXELSX), 
						pDC->GetDeviceCaps(LOGPIXELSY));
}

void CDrawingView::OnSize(UINT nType, int cx, int cy)
{			//       
	CScrollView::OnSize(nType, cx, cy);
			//      
	UpdateActiveItem();
}

void CDrawingView::UpdateActiveItem()
{
			//      
	COleClientItem* pItem = GetDocument()->
										GetInPlaceActiveItem(this);
			//   .   
	if ( pItem && pItem->GetItemState() ==
						COleClientItem::activeUIState &&
			pItem->GetActiveView() == this)
	{
			//      
		pItem->SetItemRects();
	}
}

void CDrawingView::OnDestroy() {
	CScrollView::OnDestroy();
	COleClientItem* pItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pItem && pItem->GetActiveView() == this) {
		pItem->Deactivate();
		ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
	}
}

BOOL CDrawingView::IsSelected(const CObject* pDocItem) const {
	return pDocItem == m_pSelection;
}

void CDrawingView::OnOleInsertNew()
{
	COleInsertDialog dlg;					//  OLE-
	if (dlg.DoModal() != IDOK)
		return;
	BeginWaitCursor();
	CDrawingDoc* pDoc = GetDocument();

	CDrawingCntrItem* pItem = NULL;
	try
	{										//   
		pItem = pDoc->CreateItem();
		if (!dlg.CreateItem(pItem))
			AfxThrowMemoryException();		//   
		pItem->UpdateLink();
		pItem->UpdateFromServerExtent();
		if (dlg.GetSelectionType() ==COleInsertDialog::createNewItem)
			pItem->DoVerb(OLEIVERB_SHOW, this);
		SetSelection(pItem);
	}
	catch(...)
	{										//  
		if (pItem)
			DeleteItem(pItem);
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	EndWaitCursor();
}

void CDrawingView::OnCancelEditCntr() {
	COleClientItem* pItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pItem)	pItem->Close();
	ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

void CDrawingView::OnLButtonDblClk(UINT nFlags, CPoint point) {
	if (m_pSelection)
		m_pSelection->DoVerb(GetKeyState(VK_CONTROL) < 0 ? 
			OLEIVERB_OPEN : OLEIVERB_PRIMARY, this);
}

void CDrawingView::OnSetFocus(CWnd* pOldWnd) {
	COleClientItem* pItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pItem && pItem->GetItemState() == COleClientItem::activeUIState) {
		CWnd* pWnd = pItem->GetInPlaceWindow();
		if (pWnd)	{		// if item is in the same view
			pWnd->SetFocus();		return;
		}
	}
	CScrollView::OnSetFocus(pOldWnd);
}

void CDrawingView::SetSelection(CDrawingCntrItem *pItem, bool bSafe)
{
	if ( pItem &&  pItem == m_pSelection)
		return;
	COleClientItem* p = GetDocument()->GetInPlaceActiveItem(this);
	if (p && p != pItem)
	{	// deactivate any in-place active item on this view!
		if (bSafe)  return;
		p->Close();
	}
	if (m_pSelection)						// invalidate the old item
		InvalidateItem(m_pSelection);
	if ( (m_pSelection = pItem) != NULL)	// invalidate the new item
		InvalidateItem(m_pSelection);
}

void CDrawingView::HitTestItem(CPoint pt) {
	pHit = NULL;
	CDrawingDoc* pDoc = GetDocument();
	POSITION pos = pDoc->GetStartPosition();
	while (pos)	{		// Find the item hit by the mouse
		CDrawingCntrItem* pItem = (CDrawingCntrItem*)pDoc->GetNextClientItem(pos);
		if ( !pItem )	continue;
		SetupTracker(pItem);
		if (trObj.HitTest(pt) >= 0)
			pHit = pItem;// items later in the list are drawn on top - so keep looking
	}
}

void CDrawingView::SetupTracker(CDrawingCntrItem *pItem, CRect* pTrue) {
	trObj.m_rect = pItem->rObj;
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.LPtoDP(trObj.m_rect);
	trObj.m_nStyle = 0;
	if (pItem == m_pSelection)	// resize handles if item is selected
		trObj.m_nStyle |= CRectTracker::resizeInside;
	if (pItem->GetType() == OT_LINK)
		trObj.m_nStyle |= CRectTracker::dottedLine;
	else
		trObj.m_nStyle |= CRectTracker::solidLine;
	if (pItem->GetItemState() == COleClientItem::openState ||
		pItem->GetItemState() == COleClientItem::activeUIState)
		trObj.m_nStyle |= CRectTracker::hatchInside;
	
	if (pTrue)
		trObj.GetTrueRect(pTrue);
}

BOOL CDrawingView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) {
	if ( pWnd == this && m_pSelection) {
		SetupTracker(m_pSelection);
		if (trObj.SetCursor(this, nHitTest)) //previous hit was over the object
			return TRUE;
	}
	return CScrollView::OnSetCursor(pWnd, nHitTest, message);
}

void CDrawingView::OnEditCopy() {
	if (m_pSelection)
		m_pSelection->CopyToClipboard();
	else
	{	
		CDrawingSrvrItem* pItem = GetDocument()->GetEmbeddedItem();
		if (pItem)
			pItem->CopyToClipboard(TRUE);
	}
}

void CDrawingView::OnEditPaste() {
	CDrawingCntrItem* pItem = new CDrawingCntrItem(GetDocument());
	if (!pItem->CreateFromClipboard()) {
		DeleteItem(pItem);
		AfxMessageBox(IDP_FAILED_TO_CREATE);
		return;
	}
	pItem->UpdateFromServerExtent();
	SetSelection(pItem);    
	InvalidateItem(pItem); 
}

void CDrawingView::OnEditDelobj() { DeleteItem(m_pSelection); }

void CDrawingView::DeleteItem(CDrawingCntrItem* pItem)
{				//  
	pItem = DYNAMIC_DOWNCAST(CDrawingCntrItem, pItem);
	if ( !pItem )
		return;
	GetDocument()->UpdateAllViews(0,UPD_DELITEM,pItem);
	pItem->Delete();
}

void CDrawingView::OnEditCut()
{					//    ,    OnEditCopy
	try
	{				//   
		m_pSelection->CopyToClipboard(TRUE);
		DeleteItem(m_pSelection);
	}
	catch (...)
	{				//   
		AfxMessageBox(IDP_CLIPBOARD_CUT_FAILED);
	}
}

void CDrawingView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{				//   
	if (nChar==VK_DELETE)
		DeleteItem(m_pSelection);
	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CDrawingView:: OnOleResetSize()
{			//       
 	m_pSelection->UpdateFromServerExtent();
}

void CDrawingView::OnUpdateEditMenu(CCmdUI* pCmdUI)
{	//  ,       (   )
	//       
	pCmdUI->Enable(AfxGetApp()->RunEmbedded() ||
		m_pSelection  &&  GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

void CDrawingView::OnCancelEditSrvr() {
	GetDocument()->OnDeactivateUI(FALSE);	
}

BOOL CDrawingView::PreCreateWindow(CREATESTRUCT& cs) {
	return CScrollView::PreCreateWindow(cs);
}

BOOL CDrawingView::OnPreparePrinting(CPrintInfo* pInfo) {
	pInfo->SetMaxPage(2);
	BOOL bRet = DoPreparePrinting (pInfo);	// Default preparation
	pInfo->m_nNumPreviewPages = 2;			//Preview 2 pages at a time
	return bRet;
}

void CDrawingView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/){}

void CDrawingView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/){}

void CDrawingView::OnPrint(CDC* pDC, CPrintInfo* pInfo) {
	CString s;
	int x = pInfo->m_rectDraw.right/2;
	if (pInfo->m_nCurPage == 1) {
		LOGFONT lFont;
		memset(&lFont, 0, sizeof(LOGFONT));
		lFont.lfHeight = 75; //  3/4th inch high in MM_LOENGLISH
		lFont.lfPitchAndFamily |= VARIABLE_PITCH | FF_SCRIPT;
		lFont.lfItalic = TRUE;
		CFont font, *pOld=0;
		if (font.CreateFontIndirect(&lFont))
			pOld = pDC->SelectObject(&font);
		pDC->SetTextAlign(TA_CENTER);
		pDC->TextOut(x, 200, "Drawing Picture");
		s = GetDocument()->GetTitle();
		lFont.lfHeight = 50;
		font.DeleteObject();
		font.CreateFontIndirect(&lFont);
		pDC->SelectObject(&font);
		pDC->TextOut(x, 300, s);
		if (pOld)
			pDC->SelectObject(pOld);
	}
	else {
		s = GetDocument()->GetTitle();
	    pDC->SetTextAlign(TA_LEFT);
		pDC->TextOut(0, 25, "Drawing Picture");
		pDC->SetTextAlign(TA_CENTER);
		pDC->TextOut(x, 25, s);
		TEXTMETRIC tm;
		pDC->GetTextMetrics(&tm);
		int y = 35 + tm.tmHeight;
        pDC->MoveTo(0, y);          // from left margin
		pDC->LineTo(pInfo->m_rectDraw.right, y); //  to right margin
		y += 25;     // space 1/4 inch below (top of) line
		pInfo->m_rectDraw.top += y;
        pDC->SetWindowOrg(pInfo->m_rectDraw.left,-pInfo->m_rectDraw.top);
		OnDraw(pDC);
	}
}

#ifdef _DEBUG
void CDrawingView::AssertValid() const {
	CScrollView::AssertValid();
}

void CDrawingView::Dump(CDumpContext& dc) const {
	CScrollView::Dump(dc);
}

CDrawingDoc* CDrawingView::GetDocument() {
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrawingDoc)));
	return (CDrawingDoc*)m_pDocument;
}
#endif

BOOL CMyProp::OnApplyScale (COleClientItem* p, int iScale, BOOL bRelative)
{
	if (iScale == -1)			//   ,
		return TRUE;			//  
								//   
	CDrawingCntrItem* pItem = (CDrawingCntrItem*)p;
								//     ,
	if (bRelative)				//    
		pView->OnOleResetSize();
								//   
	pView->OnUpdate(NULL, UPD_ITEM, pView->m_pSelection);

	//       (iScale)
	CSize size = pItem->rObj.Size();
	size.cx = ::MulDiv(size.cx, iScale, 100);
	size.cy = ::MulDiv(size.cy, iScale, 100);
	pItem->rObj = CRect (pItem->rObj.TopLeft(),size);
								//   
	pView->OnUpdate(NULL, UPD_ITEM, pView->m_pSelection);
	return TRUE;
}


void CDrawingView::OnOleEditProperties() 
{
 	CMyProp(m_pSelection,10,500,this).DoModal();
	GetDocument()->UpdateAllViews(NULL);
}

void CDrawingView::OnEditPasteSpecial()
{
	CDrawingDoc* pDoc = GetDocument();
	COlePasteSpecialDialog dlg;
				//      
	dlg.AddFormat(CDrawingDoc::cfClipb, TYMED_HGLOBAL,
					IDS_PRIVATE_CF_DESCR, FALSE, FALSE);
				//   
	dlg.AddStandardFormats();
	if (dlg.DoModal() != IDOK)		//  
		return;

	CDrawingCntrItem* pItem = NULL;
	try
	{
					//  ,    
		CLIPFORMAT cf = dlg.m_ps.arrPasteEntries
						[dlg.m_ps.nSelectedIndex].fmtetc.cfFormat;
					//    
		if (cf == CDrawingDoc::cfClipb)
		{
					//      
			LINKTYPE bLink = dlg.GetSelectionType() == 
				COlePasteSpecialDialog::pasteLink ? LINK : EMBED;
					//   ,  
			COleDataObject dataObject;
					//      
			dataObject.Attach(dlg.m_ps.lpSrcDataObj, FALSE);
					//     
			pItem = PasteItem(bLink, &dataObject, NULL, cf);
			pItem->UpdateLink();		//  
		}
					//    ,   
		else
		{			//    ( )
			pItem = pDoc->CreateItem();
					//      
			if (!dlg.CreateItem(pItem))
			{		//   
				TRACE0("Paste special    \n");
				AfxThrowMemoryException();
			}
			pItem->UpdateLink();
					//     
			pItem->UpdateFromServerExtent();
					//     
			pDoc->ShiftItem(pItem);
			SetSelection(pItem);	//     
			pDoc->SetModifiedFlag();
			pDoc->UpdateAllViews(NULL, UPD_ITEM, pItem);
		}
	}
	catch(...)
	{								//   
		if (pItem)
			DeleteItem(pItem);		//  
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
}

CDrawingCntrItem* CDrawingView::PasteItem(LINKTYPE bLink,
				COleDataObject* pData,CPoint* pPoint, CLIPFORMAT cf)
{
	BeginWaitCursor();		//   
	CDrawingDoc *pDoc = GetDocument();
			//    
	CDrawingCntrItem* pItem = pDoc->CreateItem();
			//    Paste/Paste Special,    
	COleDataObject clipData;
			//     ,    drag/drop
	if ( !pData )
	{		//     Clipboard,   drag/drop
		clipData.AttachClipboard();
		pData = &clipData;
	}
			//      pData
	try
	{
			//     (PasteNative)   :
			// 1.        ,
			// 2.    ,    (link)
			//     .
			//     
		if (cf == CDrawingDoc::cfClipb || !cf && bLink == EMBED
						&& pData->IsDataAvailable(CDrawingDoc::cfClipb))
			PasteNative(pData, pPoint, pItem);
					//      
					//  Drag&Drop    Paste/Paste Special
		else if ( pPoint )
			PasteStandard(bLink, pData, pPoint, pItem, cf);
		else
			PasteStandard(bLink, pData, &CPoint(10,10), pItem, cf);
		if (!pPoint)
			pDoc->ShiftItem(pItem);
		SetSelection(pItem);
		pDoc->SetModifiedFlag();
		pDoc->UpdateAllViews(0,UPD_ITEM,pItem);
		EndWaitCursor();
		return pItem;
	}
	catch (...)
	{
		DeleteItem(pItem);
		AfxMessageBox(IDP_FAILED_TO_CREATE);
		return NULL;
	}
}

void CDrawingView::PasteNative(COleDataObject* pData,
							CPoint* pPoint, CDrawingCntrItem* pItem)
{
						//        CSharedFile
	CFile* pFile = pData->GetFileData(CDrawingDoc::cfClipb);
	if ( !pFile )
		AfxThrowFileException(CFileException::generic);
	CArchive ar(pFile, CArchive::load);
	ar.m_pDocument = GetDocument();
	pItem->Serialize(ar);
	ar.Close();
	delete pFile;
						//    
	if ( pPoint )		//   Drag&Drop
		pItem->rObj = CRect (*pPoint,pItem->rObj.Size());
}

void CDrawingView::PasteStandard(LINKTYPE bLink,
						COleDataObject* pData,CPoint* pPoint,
						CDrawingCntrItem* pItem,CLIPFORMAT cf)
{
	if (bLink == LINK)
	{									//   (link)
		if (!pItem->CreateLinkFromData(pData))
			AfxThrowMemoryException();	//  
	}									//   (embedded)
	else if (!pItem->CreateFromData(pData) &&
			!pItem->CreateStaticFromData(pData, OLERENDER_DRAW, cf))
		AfxThrowMemoryException();
										//   
	HGLOBAL hObj = pData->GetGlobalData(cfDraw);

	if ( hObj )
	{					//       
		LPOBJECTDESCRIPTOR pObj =
									(LPOBJECTDESCRIPTOR)GlobalLock(hObj);
		ASSERT(pObj != NULL);
		pItem->SetDrawAspect((DVASPECT)pObj->dwDrawAspect);
		GlobalUnlock(hObj);
		GlobalFree(hObj);
	}
	
	CSize size;							//   
	if ( pPoint )						//   Drag&Drop
		pItem->rObj = CRect (*pPoint,pItem->rObj.Size());
										//   
	if ( GetObjectInfo(pData,&size,0) && size != CSize(0, 0) )
	{									//     
		CClientDC dc(this);
		dc.HIMETRICtoDP(&size);			//   
		pItem->rObj = CRect (*pPoint,size);
	}
		//       ,    
	else
		pItem->UpdateFromServerExtent();
}

void CDrawingView::OnOleChangeSource()
{
				//    
	ASSERT(m_pSelection != NULL &&
				m_pSelection->GetType() == OT_LINK);
				//  
	COleChangeSourceDialog(m_pSelection).DoModal();
}

void CDrawingView::OnUpdateOleChangeSource(CCmdUI* pCmdUI)
{
		//  ,      link
	pCmdUI->Enable(m_pSelection != NULL && 
					m_pSelection->GetType() == OT_LINK);
}

void CDrawingView::OnEditClone()
{
	if ( !m_pSelection )			//    ,
		return;						// 
	CDrawingDoc* pDoc = GetDocument();
	BeginWaitCursor();				//   
	CDrawingCntrItem* pItem = NULL;
	try
	{								//    
		pItem = pDoc->CreateItem();
									//   ,  
		if (!pItem->CreateCloneFrom(m_pSelection))
			AfxThrowMemoryException();
	}
	catch(...)
	{								//  
		if (pItem)					//  
			DeleteItem(pItem);		//    
		AfxMessageBox(IDP_FAILED_TO_CREATE);
		return;
	}
	pItem->rObj = m_pSelection->rObj;
	pItem->rObj.OffsetRect(10,10);	//   
	pDoc->UpdateAllViews(0,UPD_ITEM,pItem);
	EndWaitCursor();
}

int CDrawingView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	dropTarget.Register(this);		//  
	CDC* pDC = GetDC();				//   
									//     
	szLogScreen.cx = pDC->GetDeviceCaps(LOGPIXELSX);
	szLogScreen.cy = pDC->GetDeviceCaps(LOGPIXELSY);
	ReleaseDC(pDC);					//  

	return 0;						//  
}

void CDrawingView::OnDragLeave()
{
	CClientDC dc(this);
	if (prevDrop != DROPEFFECT_NONE)
	{							//      ,
								//   
		dc.DrawFocusRect(CRect(dragPoint,dragSize));
		prevDrop = DROPEFFECT_NONE;
	}
}

DROPEFFECT CDrawingView::OnDragOver(COleDataObject* pData,
									DWORD dwKeyState, CPoint point)
{
		//        
	point -= dragOffset;

		//   
	CRect rScroll(CPoint(0, 0), GetTotalSize());
		//  
	CRect rItem(point,dragSize);
		//    
	if (rItem.IsRectEmpty())
		rItem.InflateRect(1,1);
		//   
	rItem.OffsetRect(GetDeviceScrollPosition());
		// ,    ,   
	DROPEFFECT de = DROPEFFECT_NONE;
	CRect r;
	if (r.IntersectRect(rScroll, rItem))
	{					//    ,   
						//     (link) 
		if ((dwKeyState & (MK_CONTROL|MK_SHIFT))
								== (MK_CONTROL|MK_SHIFT))
			de = DROPEFFECT_LINK;
						//   copy
		else if ((dwKeyState & MK_CONTROL) == MK_CONTROL)
			de = DROPEFFECT_COPY;
						//   move
		else if ((dwKeyState & MK_ALT) == MK_ALT)
			de = DROPEFFECT_MOVE;
						//      move
		else
			de = DROPEFFECT_MOVE;
	}
						// .    ,   
	if (point == dragPoint)
		return de;
						// ,   
	CClientDC dc(this);
						//     
	if (prevDrop != DROPEFFECT_NONE)
		dc.DrawFocusRect(CRect(dragPoint, dragSize));
	prevDrop = de;
	if (prevDrop != DROPEFFECT_NONE)
	{					//    
		dragPoint = point;
		dc.DrawFocusRect(CRect(point, dragSize));
	}
	return de;
}

BOOL CDrawingView::OnDrop(COleDataObject* pData,
										DROPEFFECT de, CPoint point)
{
	ASSERT_VALID(this);
	OnDragLeave();					//   
									//   
	GetObjectInfo(pData, &dragSize, &dragOffset);
									//    
	CClientDC dc(this);
	dc.HIMETRICtoDP(&dragSize);
	dc.HIMETRICtoDP(&dragOffset);
	point -= dragOffset;			//   
	OnPrepareDC(&dc);				//    
	dc.DPtoLP(&point);				//  
									//      
	if ((de & DROPEFFECT_MOVE) && bFromOutside)
	{
		ASSERT(m_pSelection != NULL);
		bFromOutside = false;		//   
			//      
		if (m_pSelection->rObj.TopLeft() != point)
			m_pSelection->ChangeSelection(CRect(point,
											m_pSelection->rObj.Size()));
	}
									//    
	else if ((de & DROPEFFECT_LINK) && PasteItem(LINK, pData, &point))
		return TRUE;
									// ,   EMBED
	else if (PasteItem(EMBED, pData, &point))// paste embedding/static
		return TRUE;
	return FALSE;
}

DROPEFFECT CDrawingView::OnDragEnter(COleDataObject*pData,
						DWORD dwKeyState, CPoint point)
{
	ASSERT(prevDrop == DROPEFFECT_NONE);
		//  
	GetObjectInfo(pData, &dragSize, &dragOffset);
	CClientDC dc(this);
		//      
	dc.HIMETRICtoDP(&dragSize);
	dc.HIMETRICtoDP(&dragOffset);
	return OnDragOver(pData, dwKeyState, point);
}

bool CDrawingView::GetObjectInfo(COleDataObject* pData,
								CSize* pSz, CSize* pOffset)
{
							//   
	HGLOBAL hObj = pData->GetGlobalData(cfDraw);
	if ( !hObj )
	{						//   
		if ( pOffset )
			* pOffset = CSize(0, 0);
		*pSz = CSize(0, 0);
		return false;
	}
	
							//   ,  
							//    (  ).
	LPOBJECTDESCRIPTOR pObj =
					(LPOBJECTDESCRIPTOR)::GlobalLock(hObj);
	ASSERT(pObj != NULL);
	pSz->cx = (int)pObj->sizel.cx;
	pSz->cy = (int)pObj->sizel.cy;
	if ( pOffset )
	{
		pOffset->cx = (int)pObj->pointl.x;
		pOffset->cy = (int)pObj->pointl.y;
	}
	::GlobalUnlock(hObj);	//  
	::GlobalFree(hObj);
	return true;
}

BOOL CDrawingView::OnScrollBy(CSize sizeScroll, BOOL bDoScroll) {
	if (bDoScroll && prevDrop != DROPEFFECT_NONE)
	{							//   
		CClientDC dc(this);
		dc.DrawFocusRect(CRect(dragPoint, dragSize));
		prevDrop = DROPEFFECT_NONE;
	}
								//    
	if (!CScrollView::OnScrollBy(sizeScroll, bDoScroll))
		return FALSE;

	if (bDoScroll)
	{							//      
		UpdateActiveItem();
		UpdateWindow();
	}
	return TRUE;
}
