#if !defined(AFX_DRAWINGVIEW_H__DD4462E5_4119_11D2_8CB3_FB5BEE035FF0__INCLUDED_)
#define AFX_DRAWINGVIEW_H__DD4462E5_4119_11D2_8CB3_FB5BEE035FF0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

class CDrawingCntrItem;

class CDrawingView : public CScrollView {
	friend class CDrawingDoc;
	friend class CMyProp;
protected:
	CDrawingView();
	DECLARE_DYNCREATE(CDrawingView)
public:
	CDrawingCntrItem* m_pSelection;

	void Drag(CPoint&);
	void HitTestItem(CPoint point);
	void SetSelection(CDrawingCntrItem*, bool=false);
	void SetupTracker(CDrawingCntrItem*,CRect* pTrue=NULL);
	void DeleteItem(CDrawingCntrItem*);
	void InvalidateItem(CDrawingCntrItem*);
	void UpdateActiveItem();
	bool GetObjectInfo(COleDataObject*,CSize*,CSize*);
	CDrawingCntrItem* PasteItem(LINKTYPE,
						COleDataObject*,CPoint*,CLIPFORMAT=NULL);
	void PasteNative(COleDataObject*,CPoint*,CDrawingCntrItem*);
	void PasteStandard(LINKTYPE,COleDataObject*,CPoint*,
						CDrawingCntrItem*,CLIPFORMAT);


	CDrawingDoc* GetDocument();
	virtual ~CDrawingView();
	//{{AFX_VIRTUAL(CDrawingView)
	public:
	virtual void OnDraw(CDC* pDC);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual BOOL IsSelected(const CObject* pDocItem) const;
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnScrollBy(CSize sizeScroll, BOOL bDoScroll = TRUE);
	//}}AFX_VIRTUAL
public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
	//{{AFX_MSG(CDrawingView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnCancelEditSrvr();
	afx_msg void OnCancelEditCntr();
	afx_msg void OnEditDelobj();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnOleInsertNew();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnEditCut();
	afx_msg void OnOleResetSize();
	afx_msg void OnUpdateEditMenu(CCmdUI* pCmdUI);
	afx_msg void OnOleEditProperties();
	afx_msg void OnEditPasteSpecial();
	afx_msg void OnOleChangeSource();
	afx_msg void OnUpdateOleChangeSource(CCmdUI* pCmdUI);
	afx_msg void OnEditClone();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CClientDC* pdc;
	CPen* pPen;
	CLine* pLine;
	CPoint ptFirst;						//    
	CSize szLogScreen;					//      
	CRectTracker trObj, trDraw, *pTrack;//  
	bool bDrag;							//  :   
	CDrawingCntrItem* pHit;
	bool bFromOutside;					//  :      
	COleDropTarget dropTarget;			//    drop
	CSize dragSize;						//   
	CPoint dragPoint;					//    
	CSize dragOffset;					//    
	DROPEFFECT prevDrop;				//    
	static CLIPFORMAT cfDraw;			//    Clipboard
};

#ifndef _DEBUG  // debug version in DrawingView.cpp
inline CDrawingDoc* CDrawingView::GetDocument()
   { return (CDrawingDoc*)m_pDocument; }
#endif

class CMyProp : public COlePropertiesDialog
{								//  ,   OLE-
public:
	CMyProp(COleClientItem* p,UINT Min=10, UINT Max=500, CWnd* parent=NULL)
		: COlePropertiesDialog(p,Min,Max,parent)
	{	
		pView = (CDrawingView*)parent; 
	}
	virtual BOOL OnApplyScale(COleClientItem*,int,BOOL);
private:
	CDrawingView* pView;		//   
};

//{{AFX_INSERT_LOCATION}}

#endif
