#include "stdafx.h"
#include "Drawing.h"

#include "MainFrm.h"
#include "DrawingDoc.h"
#include "DrawingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_WINDOW_NEW_D, OnWindowNewDraw)
	ON_COMMAND(ID_WINDOW_NEW_A, OnWindowNewArray)
	ON_COMMAND(ID_EDIT_COPY_SKETCH, OnCopySketch)
	ON_COMMAND(ID_EDIT_PASTE_SKETCH, OnPasteSketch)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_SKETCH, OnUpdatePasteSketch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] = {
	ID_SEPARATOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

CMainFrame::CMainFrame(){ pDoc=NULL; }

CMainFrame::~CMainFrame(){}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) {
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs) {
	return CMDIFrameWnd::PreCreateWindow(cs);
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const {
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const {
	CMDIFrameWnd::Dump(dc);
}

#endif

void CMainFrame::OnWindowNewDraw() {
	CMDIChildWnd *pChild = MDIGetActive();
	CDocument *pD = pChild->GetActiveDocument();
	CDocTemplate *pTempl = ((CDrawingApp*)AfxGetApp())->pTemplDraw;
	CFrameWnd *pFrame = pTempl->CreateNewFrame(pD,pChild);
	pTempl->InitialUpdateFrame(pFrame, pD);
}

void CMainFrame::OnWindowNewArray() {
	CMDIChildWnd *pChild = MDIGetActive();
	CDocument *pD = pChild->GetActiveDocument();
	CDocTemplate *pTempl = ((CDrawingApp*)AfxGetApp())->pTemplArray;
	CFrameWnd *pFrame = pTempl->CreateNewFrame(pD,pChild);
	pTempl->InitialUpdateFrame(pFrame, pD);
}

void CMainFrame::OnCopySketch() {
	pDoc = MDIGetActive()->GetActiveDocument();
}

void CMainFrame::OnPasteSketch() {
	((CDrawingDoc*)MDIGetActive()->GetActiveDocument())->DoPaste(pDoc);
}

void CMainFrame::OnUpdatePasteSketch(CCmdUI* pCmdUI) {
	pCmdUI->Enable(pDoc!=NULL);	
}
