#include "stdafx.h"
#include "Drawing.h"
#include "PenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "DrawingDoc.h"

CPenDlg::CPenDlg(CDrawingDoc* p, COLORREF r, COLORREF g, COLORREF b) 
	: CDialog(CPenDlg::IDD, NULL),
	cRed(r),	cGreen(g),	cBlue(b) {
	//{{AFX_DATA_INIT(CPenDlg)
	//}}AFX_DATA_INIT
	pDoc = p;
	PenSize = p->PenSize;
	nRed   = GetRValue(p->Color);
	nGreen = GetGValue(p->Color);
	nBlue  = GetBValue(p->Color);
}

void CPenDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPenDlg)
	DDX_Control(pDX, IDC_RED, cRed);
	DDX_Control(pDX, IDC_GREEN, cGreen);
	DDX_Control(pDX, IDC_BLUE, cBlue);
	DDX_Text(pDX, IDC_BLUE, nBlue);
	DDV_MinMaxUInt(pDX, nBlue, 0, 255);
	DDX_Text(pDX, IDC_GREEN, nGreen);
	DDV_MinMaxUInt(pDX, nGreen, 0, 255);
	DDX_Text(pDX, IDC_RED, nRed);
	DDV_MinMaxUInt(pDX, nRed, 0, 255);
	DDX_Text(pDX, IDC_PEN, PenSize);
	DDV_MinMaxUInt(pDX, PenSize, 1, 150);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPenDlg, CDialog)
	//{{AFX_MSG_MAP(CPenDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CPenDlg::OnInitDialog() {
	cOk.AutoLoad(IDOK,this);
	CDialog::OnInitDialog();
	return TRUE;
}

void CPenDlg::OnOK() {
	UpdateData();
	COLORREF color = RGB(nRed, nGreen, nBlue);
	pDoc->Color = color;
	pDoc->PenSize = PenSize;
	CDialog::OnOK();
}

//=============== CClrEdit =====================//

CClrEdit::CClrEdit(COLORREF clr) {
	clrBk = clr;				//  
	clrText = ~clr;				//   -   
	brBk.CreateSolidBrush (clr);//    
}

CClrEdit::~CClrEdit(){}

BEGIN_MESSAGE_MAP(CClrEdit, CEdit)
	//{{AFX_MSG_MAP(CClrEdit)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

HBRUSH CClrEdit::CtlColor(CDC* pDC, UINT nCtlColor) {
	pDC->SetTextColor (clrText);	//  
	pDC->SetBkColor (clrBk);		//  
	return brBk;					//  
}
