#include "stdafx.h"
#include "Drawing.h"

#include "DrawingDoc.h"
#include "SrvrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CDrawingSrvrItem, COleServerItem)

CDrawingSrvrItem::CDrawingSrvrItem(CDrawingDoc* pContainerDoc)
	: COleServerItem(pContainerDoc, TRUE){}

CDrawingSrvrItem::~CDrawingSrvrItem(){}

void CDrawingSrvrItem::Serialize(CArchive& ar){
	if (!IsLinkedItem())	{
		CDrawingDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pDoc->Serialize(ar);
	}
}

BOOL CDrawingSrvrItem::OnGetExtent(DVASPECT dwDrawAspect, CSize& rSize){
	if (dwDrawAspect != DVASPECT_CONTENT)
        return COleServerItem::OnGetExtent(dwDrawAspect, rSize);
    CDrawingDoc* pDoc = GetDocument();
    rSize = pDoc->szSrvr;
    CClientDC dc(NULL);
    dc.SetMapMode(MM_ANISOTROPIC);
 	dc.SetViewportExt(dc.GetDeviceCaps(LOGPIXELSX),dc.GetDeviceCaps(LOGPIXELSY));
    dc.SetWindowExt(100,100);
	dc.LPtoHIMETRIC(&rSize);    
    return TRUE;
}

BOOL CDrawingSrvrItem::OnDraw(CDC* pDC, CSize& rSize){
	UNREFERENCED_PARAMETER(rSize);
	CDrawingDoc* pDoc = GetDocument();
	pDC->SetMapMode(MM_ANISOTROPIC);
    pDC->SetWindowExt(pDoc->szSrvr);
	pDC->SetWindowOrg(0,0);
	
	POSITION pos = pDoc->Sketch.GetHeadPosition();
    while (pos) 
        pDoc->Sketch.GetNext(pos)->Draw(pDC);
	return TRUE;
}

#ifdef _DEBUG
void CDrawingSrvrItem::AssertValid() const {
	COleServerItem::AssertValid();
}

void CDrawingSrvrItem::Dump(CDumpContext& dc) const{
	COleServerItem::Dump(dc);
}
#endif
